// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

function validatelimitedstring(x, r, o)
{
/*
    var s = " 0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_@*#.%:;\\/+", j = 0;

    for (var i = j; i < x.length; i++) {
        if (s.indexOf(x.charAt(i)) == -1) {
            alert(parent.I18N['INVALID_VALUE']);
            if (o)
                o.focus();
            return r;
        }
    }
*/
    return x;
}

function ispositivenumber(x)
{
    var s = "0123456789", j = 0;

    if (x.length == 0)
            return false;

    for (var i = j; i < x.length; i++) {
        if (s.indexOf(x.charAt(i)) == -1)
            return false;
    }
    return true;
}

function validatenumber(x, r, o)
{
    var s = parent.I18N['ONLYVALID_RANGEIN'];

    if (!ispositivenumber(x)) {
        alert(parent.I18N['INVALID_VALUE']);
        if (o)
            o.focus();
        if (r)
            return r;
        else
            return 0;
    }
    if (x < 0 || x > 65535) {
        alert(s.replace(/%a/g, "0").replace(/%b/g, "65535"));
        if (o)
            o.focus();
        if (r)
            return r;
        else
            return 0;
    }
    return x;
}

function onlyvalidnumber(x, a, b, o)
{
    var bb = false;
    var s = parent.I18N['ONLYVALID_RANGEIN'];

    if (ispositivenumber(x))
        if (x >= a && x <= b)
            bb = true;

    if (!bb) {
        alert(s.replace(/%a/g, a).replace(/%b/g, b));
        if (o)
            o.focus();
        x = a;
    }

    return bb? x: a;
}

function flatStr(va)
{
    if (va) {
        return va;
    }
    if (typeof va == 'string') {
        return '';
    }
    return '0';
}

//////////////////////////////////////////////////////////////////////
// pair

function pair (key, value)
{
    this.key = key;
    this.value = value;
}

//////////////////////////////////////////////////////////////////////
// triple

function triple (key, value, extra)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
}

//////////////////////////////////////////////////////////////////////
// quadruple

function quadruple (key, value, extra, other)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
}

//////////////////////////////////////////////////////////////////////
// quintuple

function quintuple (key, value, extra, other, misc)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
    this.misc = misc;
}

//////////////////////////////////////////////////////////////////////
// sexatuple

function sexatuple (key, value, extra, other, misc, more)
{
    this.key = key;
    this.value = value;
    this.extra = extra;
    this.other = other;
    this.misc = misc;
    this.more = more;
}


//////////////////////////////////////////////////////////////////////
// Tuple

function Tuple ()
{
    this.list = false;
    if (arguments.length > 0) {
        this.list = new Array ();
    }
    var j = this.list.length;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i]) {
            this.list[j++] = arguments[i];
        }
    }
}

function addItemIntoTuple ()
{
    if (!this.list && arguments.length > 0) {
        this.list = new Array ();
    }
    var j = this.list.length;
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i]) {
            this.list[j++] = arguments[i];
        }
    }
}

function atCompInTuple (id, compf)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (compf(this.list[i],id)) {
                return this.list[i];
            }
        }
    }
    return false;
}

function atTuple (i)
{
    if (this.list) {
        return this.list[i];
    }
    return false;
}

function lengthOfTuple ()
{
    if (this.list) {
        return this.list.length;
    }
    return 0;
}

function idAtOfTuple (id)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].id == id) {
                return this.list[i];
            }
        }
    }
    return false;
}

function keyAtOfTuple (key)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                return this.list[i];
            }
        }
    }
    return false;
}

function evalAtOfTuple (target, field)
{
    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (eval('this.list[i].' + field)) {
                if (eval('this.list[i].' + field) == target) {
                    return this.list[i];
                }
            }
        }
    }
    return false;
}

function pairAtOfTuple (key)
{
    var va = '';

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                if (va.length > 0)
                    va = va + '\n';
                if (typeof this.list[i].value == 'string')
                    va = va + this.list[i].value;
                else
                    va = this.list[i].value;
            }
        }
    }

    if (va)
        return va;
    if (typeof va == 'number')
        return 0;
    if (typeof va == 'string')
        return '';

    return false;
}

function tripleExtraAtOfTuple (key)
{
    var va = '';

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                if (va.length > 0)
                    va = va + '\n';
                if (typeof this.list[i].extra == 'string')
                    va = va + this.list[i].extra;
                else
                    va = this.list[i].extra;
            }
        }
    }

    if (va)
        return va;
    if (typeof va == 'number')
        return 0;
    if (typeof va == 'string')
        return '';

    return false;
}

function quadrupleOtherAtOfTuple (key)
{
    var va = '';

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                if (va.length > 0)
                    va = va + '\n';
                if (typeof this.list[i].other == 'string')
                    va = va + this.list[i].other;
                else
                    va = this.list[i].other;
            }
        }
    }

    if (va)
        return va;
    if (typeof va == 'number')
        return 0;
    if (typeof va == 'string')
        return '';

    return false;
}

function quintupleMiscAtOfTuple (key)
{
    var va = '';

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                if (va.length > 0)
                    va = va + '\n';
                if (typeof this.list[i].misc == 'string')
                    va = va + this.list[i].misc;
                else
                    va = this.list[i].misc;
            }
        }
    }

    if (va)
        return va;
    if (typeof va == 'number')
        return 0;
    if (typeof va == 'string')
        return '';

    return false;
}

function sexatupleMoreAtOfTuple (key)
{
    var va = '';

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                if (va.length > 0)
                    va = va + '\n';
                if (typeof this.list[i].more == 'string')
                    va = va + this.list[i].more;
                else
                    va = this.list[i].more;
            }
        }
    }

    if (va)
        return va;
    if (typeof va == 'number')
        return 0;
    if (typeof va == 'string')
        return '';

    return false;
}

function pairAtPassOfTuple (key, pass)
{
    if (this.list && pass > 0) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                pass--;
                if (pass == 0) {
                    return this.list[i].value;
                }
            }
        }
    }
    return false;
}

function pairKeyTotalOfTuple (key)
{
    var total = 0;

    if (this.list) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].key == key) {
                total++;
            }
        }
    }
    return total;
}


function sortTuple (func)
{
    if (this.list) {
        this.list.sort(func);
    }
}


Tuple.prototype.addItem = addItemIntoTuple;
Tuple.prototype.length = lengthOfTuple;
Tuple.prototype.atComp = atCompInTuple;
Tuple.prototype.at = atTuple;
Tuple.prototype.idAt = idAtOfTuple;
Tuple.prototype.keyAt = keyAtOfTuple;
Tuple.prototype.evalAt = evalAtOfTuple;

Tuple.prototype.pairAt = pairAtOfTuple;
Tuple.prototype.pairAtPass = pairAtPassOfTuple;
Tuple.prototype.pairKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.tripleValueAt = pairAtOfTuple;
Tuple.prototype.tripleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.tripleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.tripleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.quadrupleValueAt = pairAtOfTuple;
Tuple.prototype.quadrupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.quadrupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.quadrupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.quadrupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.quintupleValueAt = pairAtOfTuple;
Tuple.prototype.quintupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.quintupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.quintupleMiscAt = quintupleMiscAtOfTuple;
Tuple.prototype.quintupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.quintupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.sexatupleValueAt = pairAtOfTuple;
Tuple.prototype.sexatupleExtraAt = tripleExtraAtOfTuple;
Tuple.prototype.sexatupleOtherAt = quadrupleOtherAtOfTuple;
Tuple.prototype.sexatupleMiscAt = quintupleMiscAtOfTuple;
Tuple.prototype.sexatupleMoreAt = sexatupleMoreAtOfTuple;
Tuple.prototype.sexatupleValueAtPass = pairAtPassOfTuple;
Tuple.prototype.sexatupleKeyTotal = pairKeyTotalOfTuple;

Tuple.prototype.sort = sortTuple;