// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

var viewTitle;
var vwOrg, iwOrg;

var currMagifyDiv = false;

var iView = false;

function swapViewImage ()
{
    var vv = parent.once.theSystem.getView(iView);
    if (parent.__swapViewImage__) {
        document.images['view'].src = parent.once.imgPath + vv.simpleimage;
        parent.__swapViewImage__ = false;
    } else {
        document.images['view'].src = parent.once.imgPath + vv.complximage;
        parent.__swapViewImage__ = true;
    }
}

function getSnsrHealthCSSClass (i)
{
    switch (i) {
        case ASWM_HEALTH_FATAL:
        case ASWM_HEALTH_FATALLOW:
        case ASWM_HEALTH_FATALHIGH:
            return "t8_red";
        case ASWM_HEALTH_WARNING:
        case ASWM_HEALTH_WARNINGLOW:
        case ASWM_HEALTH_WARNINGHIGH:
            return "t8_yellow";

    }
    return "t8_blue";
}


function magnifyImage (img)
{
    if (typeof img == "string") {
        if (currMagifyDiv) {
            document.body.removeChild(currMagifyDiv);
            currMagifyDiv = false;
        }
        document.images['magnify'].src = parent.once.imgPath + img;
    } else {
        if (currMagifyDiv) {
            document.body.removeChild(currMagifyDiv);
            currMagifyDiv = false;
        }
        currMagifyDiv = document.createElement('DIV');
        currMagifyDiv.style.visibility = 'visible';
        currMagifyDiv.style.position = 'absolute';
        currMagifyDiv.style.left = getOffsetLeft(iwOrg);
        currMagifyDiv.style.top = getOffsetTop(iwOrg);
        currMagifyDiv.id = img.label;
        document.body.appendChild(currMagifyDiv);
        writeHTML(img.label, img.getHtml());
    }
}

var divViewAlarm = false;
var divViewAlarmByID = false;

function groupHealthSign (i)
{
    if ((i & 0xff) == 2)
        return "./img/z/i_danger.gif";
    if ((i & 0xff) == 1)
        return "./img/z/i_notice.gif";

    return false;
}

function getSnsrHealthSign (i)
{
    switch (i) {
        case ASWM_HEALTH_FATAL:
        case ASWM_HEALTH_FATALLOW:
        case ASWM_HEALTH_FATALHIGH:
            return "./img/z/i_danger.gif";
        case ASWM_HEALTH_WARNING:
        case ASWM_HEALTH_WARNINGLOW:
        case ASWM_HEALTH_WARNINGHIGH:
            return "./img/z/i_notice.gif";
    }

    return false;
}

function switchHealthSignState (flag)
{
    var i, vv, ss, img;

    if (divViewAlarm) {
        if (flag) {
            vv = parent.once.theSystem.getView(iView);
            for (i = 0; i < vv.alerts.length(); i++) {
                switch (vv.alerts.at(i).value) {
                    case parent.asID['IDV_TYPE_SNRGROUP']:
                        if (parent.once.HSensorGroups) {
                            ss = parent.once.HSensorGroups.idAt(vv.alerts.at(i).extra);
                            if (ss) {
                                if ((img = groupHealthSign(ss.currStatus))) {
                                    document.images[vv.alerts.at(i).key].src = img;
                                    divViewAlarm[divViewAlarmByID[vv.alerts.at(i).key]].style.visibility = 'visible';
                                } else {
                                    document.images[vv.alerts.at(i).key].src = "./img/z/i-blank.gif";
                                    divViewAlarm[divViewAlarmByID[vv.alerts.at(i).key]].style.visibility = 'hidden';
                                }
                            }
                        }
                        break;
                    case parent.asID['IDV_TYPE_SNR']:
                        if (parent.once.GSensors) {
                            ss = parent.once.GSensors.idAt(vv.alerts.at(i).extra);
                            if (ss) {
                                if ((img = getSnsrHealthSign(ss.currstatus))) {
                                    document.images[vv.alerts.at(i).key].src = img;
                                    divViewAlarm[divViewAlarmByID[vv.alerts.at(i).key]].style.visibility = 'visible';
                                } else {
                                    document.images[vv.alerts.at(i).key].src = "./img/z/i-blank.gif";
                                    divViewAlarm[divViewAlarmByID[vv.alerts.at(i).key]].style.visibility = 'hidden';
                                }
                            }
                        }
                        break;
                }
            }
        } else {
            for (i = 0; i < divViewAlarm.length; i++) {
                divViewAlarm[i].style.visibility = 'hidden';
            }
        }
    }
}

var divsRSqu = false;
var lastMagnifyID = false;

function initMagnify (vv)
{
    var i, div, vv;
    if (divsRSqu) {
        for (i = 0; i < 4; i++) {
            document.body.removeChild(divsRSqu[i]);
        }
    }
    divsRSqu = new Array ();
    for (i = 0; i < 4; i++) {
        div = divsRSqu[i] = document.createElement('DIV');
        div.style.visibility = 'hidden';
        div.style.position = 'absolute';
        div.id = 'divsRSqu' + i.toString();
        div.style.zIndex = 0;
        document.body.appendChild(div);
    }

    if (divViewAlarm) {
        for (i = 0; i < divViewAlarm.length; i++) {
            document.body.removeChild(divViewAlarm[i]);
        }
        divViewAlarm = false;
        divViewAlarmByID = false;
    }
    if (vv.alerts) {
        divViewAlarm = new Array ();
        divViewAlarmByID = new Array ();
        for (i = 0; i < vv.alerts.length(); i++) {
            div = divViewAlarm[i] = document.createElement('DIV');
            div.style.position = "absolute";
            div.style.visibility = 'hidden';
            div.style.left = getOffsetLeft(vwOrg) + vv.alerts.at(i).other.x;
            div.style.top = getOffsetTop(vwOrg) + vv.alerts.at(i).other.y;
            div.id = vv.alerts.at(i).key;
            div.style.zIndex = 1;
            document.body.appendChild(div);
            writeHTML(div.id, '<IMG name="' + div.id + '" SRC="./img/z/i_danger.gif" >');
            divViewAlarmByID[div.id] = i;
        }
    }
}

var divInfoAlarm = false;
var divInfoAlarmByID = false;

function updateInfoAlarm (id)
{
    var c, i, ss;

    if (divInfoAlarm) {
        c = parent.once.theSystemComponents.idAt(lastMagnifyID);
        if (c.alerts) {
            for (i = 0; i< c.alerts.length(); i++) {
                switch (c.alerts.at(i).extra.key) {
                    case parent.asID['IDV_TYPE_SNRGROUP']:
                        if (parent.once.HSensorGroups) {
                            ss = parent.once.HSensorGroups.idAt(c.alerts.at(i).extra.value);
                            if (ss) {
                                if (ss.currStatus) {
                                    divInfoAlarm[divInfoAlarmByID[c.alerts.at(i).key]].style.visibility = 'visible';
                                } else {
                                    divInfoAlarm[divInfoAlarmByID[c.alerts.at(i).key]].style.visibility = 'hidden';
                                }
                            }
                        }
                        break;
                    case parent.asID['IDV_TYPE_SNR']:
                        if (parent.once.GSensors) {
                            ss = parent.once.GSensors.idAt(c.alerts.at(i).extra.value);
                            if (ss) {
                                if (ss.currstatus) {
                                    divInfoAlarm[divInfoAlarmByID[c.alerts.at(i).key]].style.visibility = 'visible';
                                } else {
                                    divInfoAlarm[divInfoAlarmByID[c.alerts.at(i).key]].style.visibility = 'hidden';
                                }
                            }
                        }
                        break;
                }
            }
        }
    }
}


function hideMagnify (x, y)
{
    var i, div, a, r, vv;

    if (lastMagnifyID) {
        vv = parent.once.theSystem.getView(iView);
        lastMagnifyID = false;
        for (i = 0; i < 4; i++) {
            div = divsRSqu[i];
            div.style.visibility = 'hidden';
        }
        x -= getOffsetLeft(vwOrg);
        y -= getOffsetTop(vwOrg);

        a = vv.magnifymap.searchRectByPoint(x, y);
        if (!a) {
            magnifyImage(vv.defImage);
            defaultMagnifyInfo(iView);
        }

        if (divInfoAlarm) {
            for (i = 0; i < divInfoAlarm.length; i++) {
                document.body.removeChild(divInfoAlarm[i]);
            }
            divInfoAlarm = false;
            divInfoAlarmByID = false;
        }
    }

}

function trackMap (id)
{
    var div, i, r, vv, ar;

    r = false;
    vv = parent.once.theSystem.getView(iView);

    if (vv.magnifymap) {
        for (i = 0; i < vv.magnifymap.length(); i++) {
            ar = vv.magnifymap.at(i);
            if (ar.data.id == id) {
                r = ar.rect;
                break;
            }
        }

        if (r)
            if (lastMagnifyID != id) {
                lastMagnifyID = id;

                div = divsRSqu[0];
                div.style.left = r.left + getOffsetLeft(vwOrg);
                div.style.top = r.top + getOffsetTop(vwOrg);
                writeHTML(div.id, '<img width="' + (r.width() - 2).toString() + '" height="2" src="./img/z/r-square.gif" border="0">');

                div = divsRSqu[1];
                div.style.left = r.left + getOffsetLeft(vwOrg);
                div.style.top = r.top + getOffsetTop(vwOrg);
                writeHTML(div.id, '<img width="2" height="' + (r.height() - 2).toString() + '" src="./img/z/r-square.gif" border="0">');

                div = divsRSqu[2];
                div.style.left = r.right + getOffsetLeft(vwOrg) - 2;
                div.style.top = r.top + getOffsetTop(vwOrg);
                writeHTML(div.id, '<img width="2" height="' + (r.height() - 2).toString() + '" src="./img/z/r-square.gif" border="0">');

                div = divsRSqu[3];
                div.style.left = r.left + getOffsetLeft(vwOrg);
                div.style.top = r.bottom + getOffsetTop(vwOrg) - 2;
                writeHTML(div.id, '<img width="' + (r.width() - 2).toString() + '" height="2" src="./img/z/r-square.gif" border="0">');

                for (i = 0; i < 4; i++) {
                    div = divsRSqu[i];
                    div.style.visibility = 'visible';
                }

                specifiedMagnifyInfo (ar.data.id);
                magnifyImage(ar.data.image);

                if (divInfoAlarm) {
                    for (i = 0; i < divInfoAlarm.length; i++) {
                        document.body.removeChild(divInfoAlarm[i]);
                    }
                    divInfoAlarm = false;
                    divInfoAlarmByID = false;
                }
                if (ar.data.alerts) {
                    divInfoAlarm = new Array ();
                    divInfoAlarmByID = new Array ();
                    for (i = 0; i < ar.data.alerts.length(); i++) {
                        div = divInfoAlarm[i] = document.createElement('DIV');
                        div.style.position = "absolute";
                        div.style.visibility = "hidden";
                        div.style.left = getOffsetLeft(iwOrg) + ar.data.alerts.at(i).value.key.x;
                        div.style.top = getOffsetTop(iwOrg) + ar.data.alerts.at(i).value.key.y;
                        div.id = ar.data.alerts.at(i).key;
                        div.style.zIndex = ar.data.alerts.at(i).value.extra;
                        document.body.appendChild(div);
                        writeHTML(div.id, eval(ar.data.alerts.at(i).value.value));

                        divInfoAlarmByID[div.id] = i;
                    }
                    updateInfoAlarm(ar.data.id);
                }

            }
    }
}

var bgTbl =
'<TABLE WIDTH="270" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'<TR><TD width="8" height="8"><IMG SRC="./img/z/border_01.gif" BORDER="0"></TD>' +
'    <TD WIDTH="254" height="8"></TD>' +
'    <TD width="8" height="8"><IMG SRC="./img/z/border_02.gif" BORDER="0"></TD>' +
'</TR>' +
'<TR>' +
'    <TD align=center WIDTH="270" colspan="3">';

var edTbl =
'    </TD></TR>' +
'<TR>' +
'    <TD width="8" height="8"><IMG SRC="./img/z/border_05.gif" BORDER="0"></TD>' +
'    <TD WIDTH="254" height="8"></TD>' +
'    <TD width="8" height="8"><IMG SRC="./img/z/border_06.gif" BORDER="0"></TD>' +
'</TR>' +
'</TABLE>';

function defaultMagnifyInfo (view)
{
    var go = false, i, str = '';
    var cls = getSnsrHealthCSSClass(0);
    var r = 0;

    if (parent.once.GHealth) {
        i = parent.once.GHealth.evalAt(view, 'view');
        if (i) {
            for (j = 0; j < i.ids.length; j++) {
                id = i.ids[j];
                str += '<TR><TD WIDTH="254" class="' + cls + '">' + String(id).replace(/</g, "&lt;") + ': ' + String(i.values[j.toString() + ',' + id]).replace(/</g, "&lt;") + '</TD></TR>';
                r++;
                go = true;
            }
        }
    }

    if (parent.once.theSysViewInfoAddon) {
        i = parent.once.theSysViewInfoAddon.evalAt(view, 'view');
        if (i) {
            for (j = 0; j < i.ids.length; j++) {
                id = i.ids[j];
                str += '<TR><TD WIDTH="254" class="' + cls + '">' + String(eval(id)).replace(/</g, "&lt;") + ': ' + String(eval(i.values[j.toString() + ',' + id])).replace(/</g, "&lt;") + '</TD></TR>';
                r++;
                go = true;
            }
        }
    }
    if (!go) {
        str += '<TR><TD WIDTH="254" class="' + cls + '">' + parent.I18N['NOINFO'] + '</TD></TR>';
        r++;
    }
    str = bgTbl +
        '<TABLE WIDTH="270" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
        '<TR><TD rowspan="' + (r + 1) + '" width="8" background="./img/z/border_03.gif"><IMG SRC="./img/z/border_03.gif" width="8" height="100%" BORDER="0"></TD>' +
        '    <TD WIDTH="254" class="t8b"><u>' + parent.once.theSystem.getView(view).title.replace(/</g, "&lt;") + '</u></TD>' +
        '    <TD rowspan="' + (r + 1) + '" width="8" background="./img/z/border_04.gif"><IMG SRC="./img/z/border_04.gif" width="8" height="100%" BORDER="0"></TD></TR>' +
        str +
        '</TABLE>' + edTbl;

    writeHTML('maginfo', str);
}

function specifiedMagnifyInfo (id)
{
    var c, i, j, k, str = '', go = false;
    var cls = getSnsrHealthCSSClass(0);
    var r = 0;

    c = parent.once.theSystemComponents.idAt(id);

    if (parent.once.GHealth) {
        i = parent.once.GHealth.evalAt(id, 'view');
        if (i) {
            for (j = 0; j < i.ids.length; j++) {
                id = i.ids[j];
                str += '<TR><TD WIDTH="254" class="' + cls + '">' + String(id).replace(/</g, "&lt;") + ': ' + String(i.values[j.toString() + ',' + id]).replace(/</g, "&lt;") + '</TD></TR>';
                go = true;
                r++;
            }
        }
    }

    if (c.info) {
        for (i = 0; i < c.info.length(); i++) {
            cls = getSnsrHealthCSSClass(0);
            if (c.info.at(i).extra) {
                k = c.info.at(i).extra;
                if (typeof k == "string") {
                    j = eval(k);
                    cls = getSnsrHealthCSSClass(j);
                } else {
                    j = parent.once.GSensors.idAt(k);
                    if (j) {
                        cls = getSnsrHealthCSSClass(j.currstatus);
                    } else
                        cls = false;
                }
            }
            if (cls) {
                str += '<TR><TD WIDTH="254" class="' + cls + '">' +  String(eval(c.info.at(i).key)).replace(/</g, "&lt;") + ': ' + String(eval(c.info.at(i).value)).replace(/</g, "&lt;") + '</TD></TR>';
                go = true;
                r++;
            }
        }
    }

    if (!go) {
        str += '<TR><TD WIDTH="254" class="' + cls + '">' + parent.I18N['NOINFO'] + '</TD></TR>';
        r++;
    }

    str = bgTbl +
        '<TABLE WIDTH="270" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
        '<TR><TD rowspan="' + (r + 1) + '" width="8" background="./img/z/border_03.gif"><IMG SRC="./img/z/border_03.gif" width="8" height="100%" BORDER="0"></TD>' +
        '    <TD WIDTH="254" class="t8b"><u>' + String(eval(c.label)).replace(/</g, "&lt;") + '</u></TD>' + 
        '    <TD rowspan="' + (r + 1) + '" width="8" background="./img/z/border_04.gif"><IMG SRC="./img/z/border_04.gif" width="8" height="100%" BORDER="0"></TD></TR>' +
        str +
        '</TABLE>' + edTbl;


    writeHTML('maginfo', str);
}

function rstSysView (id)
{
    var i, str, ar, re, vv;

    if (currMagifyDiv) {
        document.body.removeChild(currMagifyDiv);
        currMagifyDiv = false;
    }

    if (divViewAlarm) {
        for (i = 0; i < divViewAlarm.length; i++) {
            document.body.removeChild(divViewAlarm[i]);
        }
        divViewAlarm = false;
        divViewAlarmByID = false;
    }

    if (divInfoAlarm) {
        for (i = 0; i < divInfoAlarm.length; i++) {
            document.body.removeChild(divInfoAlarm[i]);
        }
        divInfoAlarm = false;
        divInfoAlarmByID = false;
    }

    lastMagnifyID = false;


    iView = id;
    writeHTML('title', parent.once.theSystem.getView(iView).title.replace(/</g, "&lt;"));

    if (parent.once.theSystem.confirmView(iView)) {
        vv = parent.once.theSystem.getView(iView);
        magnifyImage(vv.defImage);
        defaultMagnifyInfo(iView);
        initMagnify(vv);
        if (parent.__swapViewImage__)
            document.images['view'].src = parent.once.imgPath + vv.complximage;
        else
            document.images['view'].src = parent.once.imgPath + vv.simpleimage;

        if (vv.magnifymap) {
            str = '<map name="map' + vv.label + '">';
            for (i = 0; i < vv.magnifymap.length(); i++) {
                ar = vv.magnifymap.at(i);
                re = ar.rect;
                str += '<area shape="rect" coords="' +
                    re.left + ',' + re.top + ',' + re.right + ',' + re.bottom +
                    '" href="#" alt="' + eval(ar.data.label) + '" onmouseover="trackMap(&quot;' + ar.data.id + '&quot;)" onmouseout="hideMagnify(event.clientX, event.clientY)" Alt="' + ar.data.label + '">';
            }
            str += '</map>';
            writeHTML('viewmap', str);
            document.images['view'].isMap = true;
            document.images['view'].useMap = "#map" + vv.label;
        } else {
            document.images['view'].isMap = false;
            document.images['view'].useMap = "#";
            writeHTML('viewmap', '');
        }
    }

}

function periodical ()
{
    var c, i, ss;

    if (!iView)
        return;

    if (!lastMagnifyID) {
        defaultMagnifyInfo(iView);
    } else {
        specifiedMagnifyInfo(lastMagnifyID);
    }

    if (lastMagnifyID) {
        updateInfoAlarm(lastMagnifyID);
    }
}

